#include   <pic.h> 	
#include	"delay.h"
#include 	"i2c.h"

void
i2c_Stop(void)
{
	SCL = 0;
	SDA = 0;			/* ensure the data is low first */
	SDA_DIR = I2C_OUTPUT;
    SCL = 1;
    SDA_DIR = I2C_INPUT;
	return;
}

void
i2c_Restart(void)
{
SDA_DIR = I2C_INPUT;
SCL = 1;
SDA = 0;
SDA_DIR = I2C_OUTPUT;
	return;
}

unsigned char
i2c_PutByte(unsigned char byte)
{
	unsigned char i = 8;
SCL=0;
do	{
		SCL=0;
        SDA = 0;
if(byte & 0x80)SDA_DIR = 1;
else SDA_DIR = 0;
SCL = 1;
byte <<= 1;
	}while(--i);
    SCL = 0;
	SDA_DIR = I2C_INPUT;			/* disable data line - listen for ack */
    SCL = 1;
	return SDA;	/* returns ack, ~ack */
}

/*unsigned char
i2c_ReadAcknowledge(void)
{
	//unsigned char ack;
	SCL = 0;
	SDA_DIR = I2C_INPUT;			
    SCL = 1;
	//ack = SDA;				
	return SDA;//ack;
}
*/
unsigned char
i2c_ReadByte(void)
{
	unsigned char i;
	unsigned char byte = 0;

	for(i=0; i<8; i++)
	{
		SCL = 0;			/* drive clock low */
		SDA_DIR = I2C_INPUT;		/* release data line */
        SCL = 1;
		byte = byte << 1;		/* read the next bit */
		byte |= SDA;
	}
	return byte;
}

void
i2c_SendAcknowledge(unsigned char status)
{
	SCL=0;
	if ( status & 0x01)
	{
		SDA=0;
		SDA_DIR = I2C_OUTPUT;
	}
	else
	{
		SDA_DIR = I2C_INPUT;
	}
	DelayUs(I2C_TM_DATA_SU);
    SCL = 1;
	DelayUs(I2C_TM_SCL_HIGH);
	return;
}
/*
unsigned char
i2c_PutByte(unsigned char data)
{
	i2c_SendByte(data);
    SCL = 0;
	SDA_DIR = I2C_INPUT;			
    SCL = 1;
	return SDA;
}
*/
unsigned char
i2c_GetByte(unsigned char more)
{
	unsigned char byte;
	byte = i2c_ReadByte();
	i2c_SendAcknowledge(more);
	return byte;
}
unsigned char
i2c_Open(unsigned char address)
{
	i2c_Start();
	//i2c_SendAddress(address);
	return i2c_PutByte(address);;
}
