

/*
 *	SDA (data) and SCL (clock) bits
 *	
 *	Special note!!!
 *	
 *	If the clock and data lines are in the same port, you will need
 *	to beware of the Read/Modify/Write issue in the PIC - since
 *	a bit set or clear on any one bit in a port will read and write
 *	back all other bits, any bits configured as input which 
 */

#define	SCL		GPIO1		/* clock on port B bit 2 */
#define	SCL_DIR		TRISIO1

#define SDA     GPIO2     /* data on port B bit 1 */
#define	SDA_DIR		TRISIO2

#define I2CTRIS TRISIO
/*#define M_SDA_INP	0x02
#define M_SDA_OUT   0xFD
#define M_SCL_INP   0x04
#define M_SCL_OUT	0xFB*/

#define I2C_INPUT	1		/* data direction input */
#define I2C_OUTPUT	0		/* data direction output */

#define I2C_READ	0x01		/* read bit used with address */
#define I2C_WRITE	0x00		/* write bit used with address */

#define FALSE		0
#define TRUE		!FALSE

#define I2C_ERROR	(-1)
#define I2C_LAST	FALSE		/* SendAck: no more bytes to send */
#define I2C_MORE	TRUE		/* SendAck: more bytes to send */

#define i2c_Start()		i2c_Restart()
#define i2c_WriteTo(address)	i2c_Open((address) | I2C_WRITE)
#define i2c_ReadFrom(address)	i2c_Open((address) | I2C_READ)

/*
 * Timings for the i2c bus. Times are rounded up to the nearest
 * micro second.
 */

#define I2C_TM_BUS_FREE		2//5
#define	I2C_TM_START_SU		1//5
#define I2C_TM_START_HD		1//4
#define I2C_TM_SCL_LOW		2//5
#define	I2C_TM_SCL_HIGH		1//4
#define I2C_TM_DATA_SU		1//1
#define	I2C_TM_DATA_HD		0//0
#define I2C_TM_SCL_TO_DATA	1//4	/* SCL low to data valid */
#define	I2C_TM_STOP_SU		1//4
#define I2C_TM_SCL_TMO		1//10	/* clock time out */

extern unsigned char		i2c_ReadByte(void);
extern void		i2c_Restart(void);
extern void		i2c_Stop(void);
extern void		i2c_SendAcknowledge(unsigned char);
extern unsigned char	i2c_PutByte(unsigned char);
extern unsigned char		i2c_GetByte(unsigned char);
extern unsigned char	i2c_Open(unsigned char);


